Thank you for participating!

**Tutorial**

Tutorial is loading...

**Solution**

```
#include <bits/stdc++.h>
using namespace std;
void solve() {
string s;
cin >> s;
if(s[0]+s[1]+s[2] == s[3]+s[4]+s[5]) {
cout << "YES" << endl;
}
else {
cout << "NO" << endl;
}
}
int main() {
int t = 1;
cin >> t;
while (t--) {
solve();
}
}
```

Idea: Errichto

**Tutorial**

Tutorial is loading...

**Solution**

```
#include "bits/stdc++.h"
using namespace std;
int main() {
int t; cin >> t;
while(t--) {
int n; cin >> n;
vector<int> a(n);
int mn = INT_MAX, ans = 0;
for(int i = 0; i < n; ++i) {
cin >> a[i];
mn = min(mn, a[i]);
}
for(int i = 0; i < n; ++i) {
ans += a[i] - mn;
}
cout << ans << "\n";
}
}
```

Idea: MikeMirzayanov

**Tutorial**

Tutorial is loading...

**Solution**

```
#include "bits/stdc++.h"
using namespace std;
int cost(string& a, string& b) {
int val = 0;
for(int i = 0; i < a.size(); ++i) {
val += abs(a[i] - b[i]);
}
return val;
}
int main() {
int t; cin >> t;
while(t--) {
int n, m; cin >> n >> m;
vector<string> s(n);
for(int i = 0; i < n; ++i) {
cin >> s[i];
}
int ans = INT_MAX;
for(int i = 0; i < n; ++i) {
for(int j = i + 1; j < n; ++j) {
ans = min(ans, cost(s[i], s[j]));
}
}
cout << ans << "\n";
}
}
```

Idea: mesanu

**Tutorial**

Tutorial is loading...

**Solution**

```
#include <bits/stdc++.h>
using namespace std;
void solve()
{
int n, m;
cin >> n >> m;
int a[n][m];
for(int i = 0; i < n; i++)
{
for(int j = 0; j < m; j++)
{
cin >> a[i][j];
}
}
int mx = 0;
for(int i = 0; i < n; i++)
{
for(int j = 0; j < m; j++)
{
int now = 0;
int ci = i, cj = j;
while(ci >= 0 && ci < n && cj >= 0 && cj < m)
{
now+=a[ci][cj];
ci--;
cj--;
}
ci = i, cj = j;
while(ci >= 0 && ci < n && cj >= 0 && cj < m)
{
now+=a[ci][cj];
ci++;
cj--;
}
ci = i, cj = j;
while(ci >= 0 && ci < n && cj >= 0 && cj < m)
{
now+=a[ci][cj];
ci--;
cj++;
}
ci = i, cj = j;
while(ci >= 0 && ci < n && cj >= 0 && cj < m)
{
now+=a[ci][cj];
ci++;
cj++;
}
now-=a[i][j]*3;
mx = max(mx, now);
}
}
cout << mx << endl;
}
int main() {
int t;
cin >> t;
while(t--)
{
solve();
}
}
```

Idea: mesanu

**Tutorial**

Tutorial is loading...

**Solution**

```
#include "bits/stdc++.h"
using namespace std;
int main() {
int t; cin >> t;
while(t--) {
int n, q; cin >> n >> q;
vector<long long> a(n), p(n);
for(int i = 0; i < n; ++i) {
cin >> a[i];
}
sort(a.rbegin(), a.rend());
for(int i = 0; i < n; ++i) {
p[i] = (i ? p[i - 1] : 0) + a[i];
}
while(q--) {
long long x; cin >> x;
int l = 1, r = n, ans = -1;
while(l <= r) {
int mid = (l + r) / 2;
if(p[mid - 1] >= x) {
ans = mid;
r = mid - 1;
} else {
l = mid + 1;
}
}
cout << ans << "\n";
}
}
}
```

Idea: MikeMirzayanov

**Tutorial**

Tutorial is loading...

**Solution**

```
#include <bits/stdc++.h>
using namespace std;
void solve()
{
int n, k;
cin >> n >> k;
int a[n];
map<int, int> mp;
for(int i = 0; i < n; i++)
{
cin >> a[i];
mp[a[i]]++;
}
vector<int> c;
for(auto x : mp)
{
if(x.second >= k)
{
c.push_back(x.first);
}
}
if(c.size() == 0)
{
cout << -1 << endl;
return;
}
sort(c.begin(), c.end());
int mx = 0;
int lans = c[0], rans = c[0];
int l = c[0];
for(int i = 1; i < c.size(); i++)
{
if(c[i]-1 == c[i-1])
{
if(c[i]-l > mx)
{
lans = l;
rans = c[i];
mx = c[i]-l;
}
}
else
{
l = c[i];
}
}
cout << lans << " " << rans << endl;
}
int main(int argc, char * argv[])
{
int t;
cin >> t;
while(t--)
{
solve();
}
}
```

1676G - White-Black Balanced Subtrees

Idea: MikeMirzayanov

**Tutorial**

Tutorial is loading...

**Solution**

```
#include <bits/stdc++.h>
using namespace std;
const int MAX = 200007;
const int MOD = 1000000007;
void solve() {
int n;
cin >> n;
vector<int> child[n + 7];
for (int i = 2; i <= n; i++) {
int x;
cin >> x;
child[x].push_back(i);
}
string s;
cin >> s;
int res = 0;
function<int(int)> dp = [&] (int x) {
int bal = (s[x - 1] == 'B') ? -1 : 1;
if (child[x].empty()) {return bal;}
for (int i : child[x]) {
bal += dp(i);
}
if (bal == 0) {res++;}
return bal;
};
dp(1);
cout << res << '\n';
}
int main() {
ios::sync_with_stdio(false);
cin.tie(nullptr);
int tt; cin >> tt; for (int i = 1; i <= tt; i++) {solve();}
// solve();
}
```

1676H1 - Maximum Crossings (Easy Version)

Idea: flamestorm

**Tutorial**

Tutorial is loading...

**Solution**

```
#include <bits/stdc++.h>
using namespace std;
const int MAX = 200007;
const int MOD = 1000000007;
void solve() {
int n;
cin >> n;
int a[n];
for (int i = 0; i < n; i++) {
cin >> a[i];
}
int res = 0;
for (int i = 0; i < n; i++) {
for (int j = i + 1; j < n; j++) {
if (a[i] >= a[j]) {res++;}
}
}
cout << res << '\n';
}
int main() {
ios::sync_with_stdio(false);
cin.tie(nullptr);
int tt; cin >> tt; for (int i = 1; i <= tt; i++) {solve();}
// solve();
}
```

1676H2 - Maximum Crossings (Hard Version)

Idea: flamestorm

**Tutorial**

Tutorial is loading...

**Solution**

```
#include <bits/stdc++.h>
using namespace std;
const int MAX = 200007;
const int MOD = 1000000007;
long long merge(int a[], int temp[], int left, int mid, int right) {
int i, j, k;
long long count = 0;
i = left;
j = mid;
k = left;
while ((i <= mid - 1) && (j <= right)) {
if (a[i] <= a[j]){
temp[k++] = a[i++];
} else {
temp[k++] = a[j++];
count += (mid - i);
}
}
while (i <= mid - 1)
temp[k++] = a[i++];
while (j <= right)
temp[k++] = a[j++];
for (i=left; i <= right; i++)
a[i] = temp[i];
return count;
}
long long mergeSort(int a[], int temp[], int left, int right){
int mid;
long long count = 0;
if (right > left) {
mid = (right + left)/2;
count = mergeSort(a, temp, left, mid);
count += mergeSort(a, temp, mid+1, right);
count += merge(a, temp, left, mid+1, right);
}
return count;
}
long long aInversion(int a[], int n) {
int temp[n];
return mergeSort(a, temp, 0, n - 1);
}
void solve() {
int n;
cin >> n;
int a[n];
for (int i = 0; i < n; i++) {
cin >> a[i];
}
long long res = aInversion(a, n);
sort(a, a + n);
long long curr = 1;
for (int i = 1; i < n; i++) {
if (a[i] != a[i - 1]) {res += (curr * (curr - 1)) / 2; curr = 1;}
else {curr++;}
}
res += (curr * (curr - 1)) / 2;
cout << res << '\n';
}
int main() {
ios::sync_with_stdio(false);
cin.tie(nullptr);
int tt; cin >> tt; for (int i = 1; i <= tt; i++) {solve();}
// solve();
}
```

It was honor to test this contest.Thanks for the Great round.Also great blog thanks for helping the community.

Thanks for the effort, much appreciated!

I had another solution for 1676G - White-Black Balanced Subtrees — I used DFS to recursively compute all vertices' values, saved them in an array and then just scanning the array for the vertices that have the equal number of white and black vertices in their subtrees. Maybe this is an easier explanation not containing DP clearly.

This approach is DP as well as you are finding and storing all the values for black and white vertices for each subtree and then later only just iterating over all vertices to check which have equal no. of white and black vertices in their subtree. Actually it is quite similar to what is being done in the editorial as well except the fact that they are just finding number of balanced subtrees while doing dfs only and you are just running a separate loop after the dfs.

I really threw on C and D cuz I'm bad at determining time complexity.

The same with D

For C, I calculated the number of operations as (100 * 50 * 8)^2 instead of (50 * 8)^2 * 100. For D, I assumed that the intended solution was actually O(n^2)

my first unrated round and I have solved all of the problem in the contest time. happy coding :) problems were so interesting.

wow..i saw ur profile if ur rating was just 12 less, your rating would go like a slingshot , just a little back,,,and so much further.

Yes you are right.. but I enjoyed this round. :)

The Time complexity of Problem D O(qlogn+n). But If we calculate for the worst-case according to given constraints then it should be -: 10^7 * 10^3 + 10^7. Also you are not considering the loop for test cases, so according to me its T.C should be. O(T*N*qlogN) However this T.C also not fast. So I am getting this doubt. Please correct me if I am wrong.

I guess you are talking about problem E but not D.

It is guaranteed $$$\sum n$$$ and $$$\sum q$$$ over all test cases don't exceed $$$1.5\times10^5$$$, so there's no need to multiply $$$T$$$ when calculating the time complexity.

On this condition, the time complexity is $$$O(q\log n)\approx 1.5\times 10^5\times 17 = 2.6\times 10^6$$$, it's able to pass easily under the 3.5 seconds time limit.

Great Round, I am really excited to see my new cyan color.

E,FandH2are really good problems.Nice Div. 4!problem h2 : Has anyone used ordered_set (multiset using pair) (pbds) ??

Can someone please help me to understand the ordered_set solution to problem H2? I understand that "order_of_key(k)" returns the number of elements strictly less than k. However, I have seen many solutions that use an ordered_set with a pair to find the number of elements i<j && a[i] >= a[j], like this one:

Why does order_of_key(a[i]) not work(to me, it seems that the index is irrelevant), and what is the functionality of pairs in an ordered_set? Any help would be appreciated.

To what I can understand, people use pairs so that they do not have to worry about equal values. Since we need to find inversion that might be equal, it is a good idea to use pair<int,int> where every value had its unique index and we can get out answers simply by using

`order_of_key`

function call. You can also do this without using pairs, just use`greater_equal<int>`

in your ordered_set typedef and use a map to store equal values.Thanks for the explanation. Your clever usage of maps along with order_of_key() helped me understand what was going on.

u can replace less with less_equal for using ordered_multiset

Here is my submission : https://mirror.codeforces.com/contest/1676/submission/156780422

Very useful. Thanks!

I loved the round! The problems all had short and clean implementations, and I had a good take taking the contest.

thanks a lot for the round. It was great. hope to have many more Div4 rounds like this.

and they sort too

Can someone please explain how the BIT approach works for H2? Or maybe redirect me to some article which explains it well. Thanks.

My BIT approach for H2:156714981

so you have to find ai >= aj for i < j, so if you know BIT than we can process range sum queries so, at each step we will calcumlate, rangesum(a[j], max(a)) = this will give count of all elements greater than j that you hav eupdated in BIT, after doing this you will inccrease count of a[j] in BIT

https://mirror.codeforces.com/blog/entry/86294 — Inversion count

Editorial solution for F in python TLE's

Hi, can someone explain why my nlogn solution failed for problem F. It got accepted during the contest and even after the hacking phase finished it was accepted. But now when I checked (14 hours) after the contest it suddenly got TLE on 18th test case.

It's because after the hacking phase is over all the solution are again tested with the test case used in hacks and so is yours, the main reason the worst time complexity is not nlogn it n^2, because the c++ unordered map uses linear data structure in case of collision to search for the elements , ideally it should be nlogn if instead of linear data structure, AVL tree is used which is the case with Java

Thank you for the explanation. So is it not suggested to use unordered_map? I usually avoid using ordered map for better time complexity, but if unordered_map is not consistent, should I just stick with ordered map or any other alternative?

Try to avoid them as much as you can but use ordered map always if Time complexity allows

Can someone please tell me why its giving tle its very similar to whats given in tutorial here is my submission https://mirror.codeforces.com/contest/1676/submission/156791528

You are getting TLE because rather than iterating over the n values in the array your loop is iterating over all values in mini to maxi which can be very large of the range 10^9 as it is given in the constraints that 1 <= a[i] <= 10^9

If you use python and get TLE in problem F, I suggest you read this blog.

https://mirror.codeforces.com/blog/entry/101817

Can someone explain F? I got confused during the contest.

you have to output a range L, R

such that every element between L, R has count greater than equal to k, if there is no element in array its count is considered zero

orz

Can somebody help me with my Solution for question F. It got accepted last night during the contest but it was rejected in the system checking stating that it is giving TLE for Test case 18. My Solution for F

I am basically doing exactly what is mentioned in the editorial but mine is getting TLE.

See this comment https://mirror.codeforces.com/blog/entry/102710?#comment-911393

https://mirror.codeforces.com/blog/entry/62393

I have experienced some shocking results in F problem where if I use unordered_map it gives me TLE but on using map its working fine! Am I missing something?

When the value of n is large (usually larger than 10^5) then because there can be high number of collisions so hashmaps gives its worst case time complexity for insertion operations that is O(n) and not O(1) which is why the overall time complexity becomes O(n^2).

The solution is to use a map as there we don't have a problem of collisions and the time complexity is logn per operation.

Please can you tell me what my submission giving TLE ?

Submission

It is because you are using unordered map and not map, I have already explained the reason in an earlier comment. Check this out if interested

Hi mesanu, for D. X-Sum my python code got TLE. I looked up the editorial, it looked similar to mine. Is it a language problem (like I have to use C++ rather than python) or I am missing something in my code?

My submission Id: 156738601

Thanks!

You don't have to use c++. Try submitting in pypy 3, it is way faster.

The time complexity of F is not O(n) as mentioned in the solution, its O(n * log(n)) since we need to sort the array.

The g question why java is used in the tle code as follows https://mirror.codeforces.com/contest/1676/submission/156893634

in ques D, why you did num-=ar[i][j]*3

cause you count it 4 times in 4 ( top right, top left, bottom left, bottom right ) diagonals.

Segment Tree for div4 round???????

Still getting TLE in Problem E even after applying lower bound binary search. Solution: https://mirror.codeforces.com/contest/1676/submission/159866893

You are sorting array and calculating sums in each query. That is the reason you are getting TLE. You can do that before first query, since those values will be same every query. See my submission.

For F, finding the longest subarray of the good values array takes O(n) time. However, we must sort the array in advance which will be a O(nlogn) operation. I think that the overall time complexity should be O(nlogn) instead of O(n). Correct me if I am wrong.

A thing to point out: There was no need to sort the array in H2 again. It was already sorted by Merge Sort.

consider this comment is deleted